//+------------------------------------------------------------------+
//|                                                       QQE-VT.mq4 |
//|                           Copyright (c) 2009, Fai Software Corp. |
//|                                    http://d.hatena.ne.jp/fai_fx/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2009, Fai Software Corp."
#property link      "http://d.hatena.ne.jp/fai_fx/"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 MediumOrchid
#property indicator_color3 DodgerBlue
#property indicator_width1 2
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT

extern int SF = 5;
int MAPeriod  =14;

double RSIraw[];
double RSIndex[];
double TR[];
double ATRRSI[];
double DeltaATRRSI[];
double TrLevelRSIFast[];
double DeltaATRRSI_2[];
double TrLevelRSISlow[];

int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0, RSIndex);
   SetIndexBuffer(1, TrLevelRSIFast);
   SetIndexBuffer(2, TrLevelRSISlow);
   SetIndexBuffer(3, RSIraw);
   SetIndexBuffer(4, TR);
   SetIndexBuffer(5, ATRRSI);
   SetIndexBuffer(6, DeltaATRRSI);
   SetIndexBuffer(7, DeltaATRRSI_2);

   IndicatorShortName(StringConcatenate("QQE-VT(", SF, ")"));
   SetIndexLabel(0, "RSIndex");
   SetIndexLabel(1, "TrLevelRSIFast");
   SetIndexLabel(2, "TrLevelRSISlow");
   return (0);
}

int start() {

   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;

   /*
   {RSI}
   rsi_r := (CLOSE - ref(CLOSE,-1));
   rsi_rs := Wilders(if(rsi_r>0,rsi_r,0),14) / Wilders(if(rsi_r<0,Abs(rsi_r),0),14);
   RSIndex:= Mov((100-(100/(1+rsi_rs))),SF,E);
   */
   for (int i = 0; i < limit; i++) RSIraw[i] = iRSI(NULL, 0, MAPeriod, PRICE_CLOSE, i);
   for (i = 0; i < limit; i++) RSIndex[i] = iMAOnArray(RSIraw, 0, SF, 0, MODE_EMA, i);


   /*
   {ATR RSI}
   TH :=if(Ref(RSIndex,-1) > RSIndex,Ref(RSIndex,-1),RSIndex);
   TL :=if(Ref(RSIndex,-1) < RSIndex,Ref(RSIndex,-1),RSIndex);
   TR :=TH-TL;
   ATRRSI:=Wilders(TR,14);
   */
   double TH,TL;   
   for (i = 0; i < limit; i++) {
      TH = MathMax(RSIndex[i + 1], RSIndex[i]);
      TL = MathMin(RSIndex[i + 1], RSIndex[i]);
      TR[i] = TH - TL;
   }
   for (i = 0; i < limit; i++) ATRRSI[i] = iMAOnArray(TR, 0, MAPeriod, 0, MODE_SMMA, i);
   
   /* DeltaATRRSI:= Wilders(ATRRSI,14)*2.618; */
   for (i = 0; i < limit; i++) DeltaATRRSI[i] = iMAOnArray(ATRRSI, 0, MAPeriod, 0, MODE_SMMA, i)*2.618;

   /*
   TrLevelRSIFast:=If(
            RSIndex=PREV,
            PREV,
            If(
               ((Ref(RSIndex,-1)<PREV)AND (RSIndex<PREV)),
               Min(PREV,RSIndex + DeltaATRRSI),
               If(
                  (Ref(RSIndex,-1)>PREV) AND (RSIndex>PREV),
                  Max(PREV,RSIndex - DeltaATRRSI),
                  If(
                     RSIndex>PREV,
                     RSIndex - DeltaATRRSI,
                     RSIndex + DeltaATRRSI
                  )
               )
            )
         );
   */
   for (i = limit; i >= 0; i--) {
      if (RSIndex[i] == TrLevelRSIFast[i + 1]) {
         TrLevelRSIFast[i] = RSIndex[i];
         continue;
      }
      if (RSIndex[i + 1] < TrLevelRSIFast[i + 1] && RSIndex[i] < TrLevelRSIFast[i + 1]) {
         TrLevelRSIFast[i] = MathMin(TrLevelRSIFast[i + 1], RSIndex[i] + DeltaATRRSI[i]);
         continue;
      }
      if (RSIndex[i + 1] > TrLevelRSIFast[i + 1] && RSIndex[i] > TrLevelRSIFast[i + 1]) {
         TrLevelRSIFast[i] = MathMax(TrLevelRSIFast[i + 1], RSIndex[i] - DeltaATRRSI[i]);
         continue;
      }
      if (RSIndex[i] > TrLevelRSIFast[i + 1]) {
         TrLevelRSIFast[i] = RSIndex[i] - DeltaATRRSI[i];
         continue;
      }
      TrLevelRSIFast[i] = RSIndex[i] + DeltaATRRSI[i];
   }

   /* DeltaATRRSI_2:= Wilders(ATRRSI,14)*4.236; */
   for (i = 0; i < limit; i++) DeltaATRRSI_2[i] = iMAOnArray(ATRRSI, 0, MAPeriod, 0, MODE_SMMA, i)*4.236;
   
   /*
   TrLevelRSISlow:=If(
            RSIndex=PREV,
            PREV,
            If(
               ((Ref(RSIndex,-1)<PREV)AND (RSIndex<PREV)),
               Min(PREV,RSIndex + DeltaATRRSI_2),
               If(
                  (Ref(RSIndex,-1)>PREV) AND (RSIndex>PREV),
                  Max(PREV,RSIndex - DeltaATRRSI_2),
                  If(
                     RSIndex>PREV,
                     RSIndex - DeltaATRRSI_2,
                     RSIndex + DeltaATRRSI_2
                  )
               )
            )
         );
   */
   for (i = limit; i >= 0; i--) {
      if (RSIndex[i] == TrLevelRSISlow[i + 1]) {
         TrLevelRSISlow[i] = RSIndex[i];
         continue;
      }
      if (RSIndex[i + 1] < TrLevelRSISlow[i + 1] && RSIndex[i] < TrLevelRSISlow[i + 1]) {
         TrLevelRSISlow[i] = MathMin(TrLevelRSISlow[i + 1], RSIndex[i] + DeltaATRRSI_2[i]);
         continue;
      }
      if (RSIndex[i + 1] > TrLevelRSISlow[i + 1] && RSIndex[i] > TrLevelRSISlow[i + 1]) {
         TrLevelRSISlow[i] = MathMax(TrLevelRSISlow[i + 1], RSIndex[i] - DeltaATRRSI_2[i]);
         continue;
      }
      if (RSIndex[i] > TrLevelRSISlow[i + 1]) {
         TrLevelRSISlow[i] = RSIndex[i] - DeltaATRRSI_2[i];
         continue;
      }
      TrLevelRSISlow[i] = RSIndex[i] + DeltaATRRSI_2[i];
   }
   
   return (0);
}